function [costdata] = mbb  
clear all
clc
        fid = fopen('iterate1.txt','wt');
fcell=fun;
icostdata=[];
%for n=1000:1000:10000
     n=1000;
    ycell=fzero(n);
    for j=1:73;
        np=j;
       [x,rcostdata] = mbb(n,np,ycell{j}.',fcell{j});        
        icostdata=[icostdata;rcostdata];
    end
%end    
    fprintf(fid,'%6i  %6i  %6i %16.8f    \n',icostdata.');
         fclose(fid);            
%--------------------------------------          
    function  [X, costdata] = mbb(n,np,x,fun) 
zaman = cputime;
      eps  = 10.d0^(-6);  
      epsf = 10.d0^(-20);    
      
%-------------------------------------- Parameters in backtracking      
      gama=0.0001d0;        
      s=0.8d0;  
	  etak=0.7d0;
	  
	     lmdamax =10.d0^30;
	     lmdamin =10.d0^(-30);	  
            
      delta=10.d0;  
      maxiter=7000;  
      maxfgcnt=27000;
%------------------------------------------------      
        itert  = 0;
        fgcntt = 0;
      iter=1;
      fgcnt=0; 
      ngama =0;  
%                    =====      Beginning the algorithms    =====   

        [fx,grad] = feval(fun,x);
        fgcnt=fgcnt+1;        
        fxmin=fx ;
		
        ck=fx;
        qk=1  ;      
%------------------------------------- Direction
        d = -grad;     
        ps = dot(d,grad);
[step,fgval] = back(x,fun,d,fx,ps,gama,s,fgcnt);
fgcnt = fgval;
        gradn = (norm(grad))^2;         
           
% ------------------------------------ Begin Iterations 
while 2~=1
          xnew = x - step * grad;      
          [fxnew,gradnew] = feval(fun,xnew);
          fgcnt=fgcnt+1; 
		
		    nck=etak*qk*ck+fxnew;
		    qk=etak*qk+1;
		    ck=nck/qk;    
%-------------------------------------------> gama Barzilai & Borwein
          bs = xnew-x;
          by = gradnew - grad;
                sumg = gradnew + grad;		
          sy =  bs.'*by;
          ss = bs.'*bs;
		     yy = by.'*by;
		     gs = grad.'*bs;
		     gnews = gradnew.'*bs;		
		     sumgs = sumg.'*bs;
             
 		alpha3 = ss/(6.d0*(fx-fxnew)+4.d0*gnews+2.d0*gs);             
% % % %  		alpha4 = ss/(2.d0*(fx-fxnew)+2.d0*gnews);
			
% % % %  phi = 4.d0*(fx-fxnew)+2.d0*sumgs;beta=1.d0+phi/sy;alpha1=sy/(beta*yy);
% % % %  phi = 2.d0*(fx-fxnew)+sumgs;    beta=1.d0+phi/sy; alpha1=sy/(beta*yy);

% % % %            phi = 2.d0*(fx-fxnew)+sumgs;          	    
% % % % 		   yh = by + (phi/ss)*bs;
% % % % 		   yhyh = yh.'*yh;
% % % %         alpha5=(6.d0*(fx-fxnew)+4.d0*gnews+2.d0*gs)/yhyh;		
% % % %         alpha6=(2.d0*(fx-fxnew)+2.d0*gnews)/yhyh;

%  alpha1 = ss/(4.d0*(fx-fxnew)+3.d0*gnews+gs); 
%  alpha2=(4.d0*(fx-fxnew)+3.d0*gnews+gs)/yhyh;		
%  alpha3=ss/(beta*sy);
		         	   
		     alpha=alpha3;
             
%        if (alpha < 0.d0) 
%            alpha=ss/sy;
%        end
       if (alpha < 0.d0) 
	         alpha = lmdamax;
	     else 
		     alpha = min(lmdamax,max(lmdamin,alpha));
		    end 
		        stepini = alpha;	       
          d =-gradnew;
          ps =  d.'*gradnew;
%------------------------------------------------- Backtracking
    step=stepini;
    [step,fgval] = backnew(xnew,fun,d,fxmin,ps,gama,s,stepini,fgcnt,ck); 
   fgcnt =  fgval;
% ------------------------------------------------ STOP criterion
   ginf = norm(gradnew, inf);   
        if(ginf <= eps |  abs(step*ps) <= epsf*abs(fxnew)) 
            X=x;
            zaman = cputime - zaman;
		    costdata=[np,iter,fgcnt, zaman ];
            return
        end
        iter=iter+1;
        if(iter > maxiter | fgcnt > maxfgcnt)
            zaman = cputime - zaman;
            X=x;
            costdata=[np, -1, -1, -1];
            disp([n  np]);
            return
        end
	
%-----------------------------------------------------------------   
            
%---------------------------------------- Updating for a new iteration         

          x = xnew;
          grad = gradnew;               
          fx=fxnew;
          gradn = (norm(grad))^2; 
            
 end            %(while)      
%---------------------------------------- go to 1        
        
        
        
        
        
        
        
        
        
% Subroutine for backtracking.
    
function [step,fgval] = back(x,fun,d,fx,ps,gama,s,fgcnt) ;    

      step=1.d0;
      nt=1;
      while 2~=1
        y=x + step*d; 
        [fy zz] = feval(fun,y);
        fgcnt=fgcnt+1;
        fgval=fgcnt;
        if(fy > fx + gama*step*ps) 
            step = step * s;
            nt=nt+1;  
        else
            return
        end
      end


% Subroutine for backtracking for the New algorithm

function [step,fgval] = backnew(x,fun,d,fx,ps,gama,s,stepini,fgcnt,ck)  ;     
      step=stepini; maxfgcnt=27000;
      nt=1;
      while 2~=1
        y=x + step*d; 
        [fy zz] = feval(fun,y);
        fgcnt=fgcnt+1;
        fgval=fgcnt;
        if (fgcnt > maxfgcnt) 
            return
        end
        if(fy > ck + gama*step*ps) 
            step = step * s;
            nt=nt+1;  
        else 
            return
        end
      end    

